import 'package:diplomaticquarterapp/core/enum/viewstate.dart';
import 'package:diplomaticquarterapp/core/model/pharmacies/Addresses.dart';
import 'package:diplomaticquarterapp/core/model/pharmacies/order_detail.dart';
import 'package:diplomaticquarterapp/core/model/pharmacies/payment-checkout-data.dart';
import 'package:diplomaticquarterapp/core/viewModels/pharmacyModule/OrderPreviewViewModel.dart';
import 'package:diplomaticquarterapp/core/viewModels/pharmacyModule/order_model_view_model.dart';
import 'package:diplomaticquarterapp/core/viewModels/project_view_model.dart';
import 'package:diplomaticquarterapp/models/Appointments/AppoimentAllHistoryResultList.dart';
import 'package:diplomaticquarterapp/models/Authentication/authenticated_user.dart';
import 'package:diplomaticquarterapp/pages/base/base_view.dart';
import 'package:diplomaticquarterapp/pages/pharmacies/screens/cart-page/payment_bottom_widget.dart';
import 'package:diplomaticquarterapp/pages/pharmacies/screens/payment-method-select-page.dart';
import 'package:diplomaticquarterapp/pages/pharmacies/widgets/ProductOrderPreviewItem.dart';
import 'package:diplomaticquarterapp/pages/pharmacy/pharmacyAddresses/PharmacyAddresses.dart';
import 'package:diplomaticquarterapp/uitl/app_toast.dart';
import 'package:diplomaticquarterapp/uitl/translations_delegate_base.dart';
import 'package:diplomaticquarterapp/widgets/data_display/text.dart';
import 'package:diplomaticquarterapp/widgets/in_app_browser/InAppBrowser.dart';
import 'package:diplomaticquarterapp/widgets/others/app_scaffold_widget.dart';
import 'package:diplomaticquarterapp/widgets/others/network_base_view.dart';
import 'package:diplomaticquarterapp/widgets/transitions/fade_page.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

class SelectPaymentOptionWidget extends StatefulWidget {
  final OrderPreviewViewModel model;

  SelectPaymentOptionWidget(this.model);

  @override
  _SelectPaymentOptionWidgetState createState() =>
      _SelectPaymentOptionWidgetState();
}

class _SelectPaymentOptionWidgetState extends State<SelectPaymentOptionWidget> {
  PaymentOption paymentOption;

  _navigateToPaymentOption() {
    Navigator.push(context, FadePage(page: PaymentMethodSelectPage()))
        .then((result) => {
              setState(() {
                if (result != null) {
                  paymentOption = result;
                  widget.model.paymentCheckoutData.paymentOption =
                      paymentOption;
                }
              })
            });
  }

  @override
  void initState() {
    if (widget.model.paymentCheckoutData.paymentOption != null) {
      paymentOption = widget.model.paymentCheckoutData.paymentOption;
    }
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      color: Colors.white,
      child: paymentOption == null
          ? InkWell(
              onTap: () => {_navigateToPaymentOption()},
              child: Container(
                margin: EdgeInsets.symmetric(vertical: 12, horizontal: 12),
                child: Row(
                  children: [
                    Image.asset(
                      "assets/images/pharmacy_module/ic_payment_option.png",
                      width: 30.0,
                      height: 30.0,
                      fit: BoxFit.scaleDown,
                    ),
                    Expanded(
                      child: Container(
                        padding:
                            EdgeInsets.symmetric(vertical: 0, horizontal: 6),
                        child: Texts(
                          TranslationBase.of(context).selectPaymentOption,
                          fontSize: 14,
                          fontWeight: FontWeight.bold,
                          color: Color(0xff0000ff),
                        ),
                      ),
                    ),
                    Icon(
                      Icons.arrow_forward_ios,
                      size: 20,
                      color: Colors.grey.shade400,
                    ),
                  ],
                ),
              ),
            )
          : Container(
              margin: EdgeInsets.symmetric(vertical: 12, horizontal: 12),
              child: Row(
                children: [
                  Image.asset(
                    "assets/images/pharmacy_module/ic_payment_option.png",
                    width: 30.0,
                    height: 30.0,
                    fit: BoxFit.scaleDown,
                  ),
                  Container(
                    margin: EdgeInsets.symmetric(horizontal: 8),
                    padding: EdgeInsets.symmetric(horizontal: 4, vertical: 0),
                    decoration: new BoxDecoration(
                      color: Colors.grey.shade100,
                      shape: BoxShape.rectangle,
                    ),
                    child: Image.asset(
                      widget.model.getPaymentOptionImage(paymentOption),
                      width: 30.0,
                      height: 30.0,
                      fit: BoxFit.scaleDown,
                    ),
                  ),
                  Expanded(
                    child: Container(
                      padding: EdgeInsets.symmetric(vertical: 0, horizontal: 6),
                      child: Texts(
                        widget.model.getPaymentOptionName(paymentOption),
                        fontSize: 14,
                        fontWeight: FontWeight.bold,
                        color: Colors.black,
                      ),
                    ),
                  ),
                  InkWell(
                    onTap: () => {_navigateToPaymentOption()},
                    child: Texts(
                      TranslationBase.of(context).changeMethod,
                      fontSize: 12,
                      fontWeight: FontWeight.normal,
                      color: Color(0xff0000ff),
                    ),
                  ),
                ],
              ),
            ),
    );
  }
}
